<?php
/*  Page Integrator for DotClear
 *  Copyright (C) 2004  Sbastien LECACHEUR
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


//TODO : Replace dirname(__FILE__).'/../../../.. by a prettier method


class dcIntegrator {
	function makeLink($name,$page) {
		if (dc_url_scan == 'path_info' ) {
			?><a href="<?php dcInfo('url');?>/show/<?php echo $page;?>"><?php echo $name;?></a><?php
		} elseif (dc_url_scan == 'query_string' ) {
			?><a href="<?php dcInfo('url');?>?show/<?php echo $page;?>"><?php echo $name;?></a><?php
		} else {
			?><a href="show/<?php echo $page;?>"><?php echo $name;?></a><?php
		}
	}


	function includePage() {
		global $view;


		// Read the configuration file
		$plugin_name = 'pageintegrator';
		$ini_file = dirname(__FILE__).'/'.$plugin_name.'.ini';
		$objIni = new iniFile($ini_file);
		$objIni->read($ini_file);

		// Check if the mapping mode is activated
		if (plugin_mapping_active) {
			// Load the mapping file
			$pageMapping = parse_ini_file(dirname(__FILE__).'/'.plugin_mapping_file);

			// Search the real file name with the mapped name
			if (!empty($pageMapping[$view])) {
				clearStatCache();
				$pageToInclude = dirname(__FILE__).'/../../../..'.plugin_page_dir.'/'.$pageMapping[$view].'.'.plugin_page_ext;
				if ( file_exists($pageToInclude )) {
					include($pageToInclude);
				} else {
					printf(__('%s not found'),$pageMapping[$view].'.'.plugin_page_ext);
				}
			} else {
				printf(__('map not found : %s'),$view);
			}
		} else {
			clearStatCache();
			$pageToInclude = dirname(__FILE__).'/../../../..'.plugin_page_dir.'/'.$view.'.'.plugin_page_ext;
			if ( file_exists($pageToInclude )) {
				include($pageToInclude);
			} else {
				printf(__('%s not found'),$view.'.'.plugin_page_ext);
			}
		}
	}
}


?>