<?php
/*  Page Integrator for DotClear
 *  Copyright (C) 2004  Sbastien LECACHEUR
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

$plugin_name = 'pageintegrator';
$ini_file = dirname(__FILE__).'/'.$plugin_name.'.ini';

$objIni = new iniFile($ini_file);
$objIni->read($ini_file);

$err = '';

$url = 'tools.php?p='.$plugin_name;
$is_writable = false;


if (!is_writable($ini_file)) {
	$err = '<p>'.sprintf(__('Config file %s, is not writable.'),'<strong>./'.$plugin_name.'.ini</strong>').'</p>';
} else {
	$is_writable = true;

	# Modification du fichier
	if (!empty($_POST)) {
		$p_plugin_page_dir = trim($_POST['p_plugin_page_dir']);
		$p_plugin_page_ext = trim($_POST['p_plugin_page_ext']);
		$p_plugin_mapping_active = trim($_POST['p_plugin_mapping_active']);
		$p_plugin_mapping_file = trim($_POST['p_plugin_mapping_file']);

		{
			$objIni = new iniFile($ini_file);
			$objIni->editVar('plugin_page_dir', $p_plugin_page_dir);
			$objIni->editVar('plugin_page_ext', $p_plugin_page_ext);
			$objIni->editVar('plugin_mapping_active',(integer) $p_plugin_mapping_active);
			$objIni->editVar('plugin_mapping_file', $p_plugin_mapping_file);

			if ($objIni->saveFile() != false) {
				if (defined('DC_UPDATE_FILE_W') && DC_UPDATE_FILE_W) {
					files::touch(DC_UPDATE_FILE,time());
				}
				header('Location: '.$url.'&done=1');
				exit;
			} else {
				$err = __('An error occured while writing the file.');
			}
		}
	} else {
		if ( strlen(plugin_page_dir) == 0) {
			$dc_ini_file = dirname(__FILE__).'/../../../conf/dotclear.ini';
			$objDcIni = new iniFile($dc_ini_file);
			$p_plugin_page_dir = dc_app_url.'/share';
			$objIni->editVar('plugin_page_dir', $p_plugin_page_dir);
			if ( $objIni->saveFile() != false ) {
				if (defined('DC_UPDATE_FILE_W') && DC_UPDATE_FILE_W) {
					files::touch(DC_UPDATE_FILE,time());
				}
				header('Location: '.$url.'&done=1');
				exit;
			} else {
				$err = __('An error occured while writing the file.');
			}
		}
	}
}


/* Affichage
-------------------------------------------------------- */
buffer::str('<h2>'.__('Page Integrator').'</h2>');

if($err != '')
{
	buffer::str('<div class="erreur"><p><strong>'.__('Error(s)').' :</strong></p>'.$err.'</div>');
}

if ($is_writable)
{

	if (!empty($_GET['done'])) {
		buffer::str(
		'<p class="message">'.__('Configuration file successfully updated.').'</p>'
		);
	}

	buffer::str(
	'<form action="'.$url.'" method="post">'.
	'<fieldset class="clear">'.
	'<legend>'.__('Base configuration').'</legend>'.
	'<p class="field"><label for="p_plugin_page_dir"><strong>'.
	__('Pages dir').'&nbsp;:</strong> '.
	'('.sprintf(__('From %s'),'http://'.$_SERVER['SERVER_NAME']).') '.
	helpLink('index&amp;plugin='.$plugin_name,'p_plugin_page_dir').'</label>'.
	form::field('p_plugin_page_dir',40,'',htmlspecialchars(plugin_page_dir)).
	'</p>'.
	'<p class="field"><label for="p_plugin_page_ext"><strong>'.
	__('Pages extension').'&nbsp;:</strong> '.
	helpLink('index&amp;plugin='.$plugin_name,'p_plugin_page_ext').'</label>'.
	form::field('p_plugin_page_ext',40,'',htmlspecialchars(plugin_page_ext)).
	'</p>'.
	'<p class="field"><label for="p_plugin_mapping_active"><strong>'.
	__('Use mapping').'&nbsp;:</strong> '.
	helpLink('index&amp;plugin='.$plugin_name,'p_plugin_mapping_active').'</label>'.
	form::combo('p_plugin_mapping_active',array(__('yes')=>1,__('no')=>0),(integer) plugin_mapping_active).
	'</p>'.
	'<p class="field"><label for="p_plugin_mapping_file"><strong>'.
	__('Mapping file').'&nbsp;:</strong>'.
	helpLink('index&amp;plugin='.$plugin_name,'p_plugin_mapping_file').'</label>'.
	form::field('p_plugin_mapping_file',40,'',htmlspecialchars(plugin_mapping_file)).
	'</p>'.
	'</fieldset>'.

	'<p class="field"><input class="submit" type="submit" value="'.__('save').'" /></p>'.
	'</form>'
	);


	buffer::str('<fieldset class="clear">'.'<legend>'.__('Utilisation').'</legend>');
	buffer::str('<p>'.__('Add the fowolling code after the error displaying in your main template file').' (template.php) : </p>');
	buffer::str(
		'<i><pre>' . "\n" .
		htmlentities( '<?php' ) . "\n" .
		'if ($err_msg != \'\') : /* Si on a une quelconque erreur, on l\'affiche */'.
		htmlentities( '?>' ) . "\n" .
		htmlentities('<div class="error"><strong>').'Erreur : '.htmlentities('</strong>').
		htmlentities( '<?php' ) . ' echo $err_msg; '.htmlentities( '?>' ).htmlentities('</div>').
		'</pre></i>' . "\n"
		);
	buffer::str(
		'<pre>' . "\n" .
		htmlentities( '<?php' ) . "\n" .
		'elseif ($mode == \'show\') : dcIntegrator::includePage();' . "\n" .
		htmlentities( '?>' ) . "\n" .
		'</pre>' . "\n"
		);

	if (file_exists(dirname(__FILE__).'/../../../' . DC_ECRIRE . '/tools/filemanager/')) {
	    if ( file_exists( dirname(__FILE__) . '/../../../themes/'. dc_theme . '/template.php') ) {
	       $template_file =  '/themes/'. dc_theme . '/template.php';
	    } else {
	      $template_file =  '/themes/default/template.php';
	    }

	    buffer::str(

		'<h4>' . __('Step by step') . '</h4>' .
		'<ol>' .
		'<li>' . __('Copy the PHP code above') . '</li>' .
		'<li>'. '<a href="tools.php?p=filemanager&f=' . $template_file . '">'. __('Edit your main template file'). '</a></li>' .
		'<li>'.__('Paste the PHP code after the error displaying') . '</li>' .
		'<li>'.__('You can use links like :') .
		'<pre>'.htmlentities( '<a href="?show/masked_page">').__('View my page').htmlentities( '</a>').'</pre>' .
__('Or use this following PHP code :').
		'<pre>'.htmlentities( '<?php dcIntegrator::makeLink(\'').__('View my page').htmlentities('\',\'masked_page\');?>').'</pre>' .
		'</li>' .
		'<li>'.__("That's all :-)") . '</li>' .
		'</ol>'

	    );


    buffer::str(  '<h3>'.__('Advanced configuration').'</h3>' );
    buffer::str(  '<p>'. '<a href="tools.php?p=filemanager&f=/' . DC_ECRIRE . '/tools/'.$plugin_name.'/'.$plugin_name.'.ini">'. __('Edit Integrator Page main config file'). '</a></p>' );
    buffer::str(  '<p>'. '<a href="tools.php?p=filemanager&f=/' . DC_ECRIRE . '/tools/'.$plugin_name.'/'.plugin_mapping_file.'">'. __('Edit your mapping file'). '</a></p>' );

}
	buffer::str('</fieldset>');


	buffer::str('<fieldset class="clear">'.'<legend>'.__('Files informations').'</legend>');
	$img_check = '<img src="images/check_%s.png" alt="" />';
	if (is_writable(dirname(__FILE__).'/../../../' . DC_ECRIRE . '/tools/'.$plugin_name.'/'.$plugin_name.'.ini')) {
		buffer::str(
		'<p>'.sprintf($img_check,'on').' '.
		sprintf(__('File %s is writable.'),  DC_ECRIRE . '/tools/'.$plugin_name.'/'.$plugin_name.'.ini').
		'</p>'
		);
	} else {
		buffer::str(
		'<p>'.sprintf($img_check,'off').' '.
		sprintf(__('File %s is not writable.'), DC_ECRIRE . '/tools/'.$plugin_name.'/'.$plugin_name.'.ini').
		'</p>'
		);
	}
	if (is_writable(dirname(__FILE__).'/../../../' . DC_ECRIRE . '/tools/'.$plugin_name.'/'.plugin_mapping_file)) {
		buffer::str(
		'<p>'.sprintf($img_check,'on').' '.
		sprintf(__('File %s is writable.'),  DC_ECRIRE . '/tools/'.$plugin_name.'/'.plugin_mapping_file).
		'</p>'
		);
	} else {
		buffer::str(
		'<p>'.sprintf($img_check,'off').' '.
		sprintf(__('File %s is not writable.'), DC_ECRIRE . '/tools/'.$plugin_name.'/'.plugin_mapping_file).
		'</p>'
		);
	}
	buffer::str('</fieldset>');
}


?>
